/* concurrent.c 
 *    Test program to exercise Nachos thread related system calls
 */

#include "io_lib.h"

/* helper is the function run by each thread */
/* threadnumber is an integer used to identify the thread */
/* helper prints its threadnumber three times, yielding
 *  after each print, then terminates.
 */
void
helper(int threadnumber) 
{
  int i;
  for(i=0;i<3;i++) {
    printInt(threadnumber); /* printInt function from io_lib */
    ThreadYield();
  }
  /* we don't know the order in which the concurrent threads will
     finish.  However, the when the last thread calls ThreadExit,
     the process should terminate with exit status 0.
     (see syscall.h)
  */
  ThreadExit();
}

int
main()
{
  int i;
  /* create 4 threads */
  for(i=1;i<=4;i++) {
    if (ThreadFork(helper,i) < 0) {
      print("error creating thread\n");  /* print function from io_lib */
    }
  }
  helper(0);
}


