#include "syscall.h"
#include "io_lib.h"
#include "errno.h"

const char read_only[13] = "Hello World\n";

int main() {
    char buf[128];
    int numRead;
    int numWritten;

    Write("\nRunning console error tests...\n", 33, ConsoleOutId );

    Write("Trying to read from output console...", 37, ConsoleOutId );
    numRead = 0;
    numRead = Read(buf, 5, ConsoleOutId );
    if( numRead == -1 ) {
	Write(" failed! (it should)\n", 21, ConsoleOutId );
    } else {
        Write(" succeeded! This is an error\n", 29, ConsoleOutId );
	Exit(1);
    }

    print("Trying to read a negative number of bytes...");
    numRead = 0;
    numRead = Read(buf, -2, ConsoleInId );
    if( numRead < 0 ) {
	print(" failed! (it should)\n");
    } else {
	print("succeeded! This is an error!\n");
	Exit(1);

    }

    print("Trying to read data (five chars) into an invalid address...");
    numRead = 0;
    numRead = Read(&buf[256], 5, ConsoleInId );
    if( numRead == -1 ) {
	print(" failed! (it should)\n");
    } else {
	print("succeeded! This is an error!\n");
	Exit(1);
    }

    print("Trying to read (five chars) into readonly memory...");
    numRead = 0;
    numRead = Read( (char *)read_only, 5, ConsoleInId );
    if( numRead <= 0 ) {
	print(" failed! (it should)\n");
    } else {
	print("succeeded! This is an error!\n");
	/*Exit(1);*/
    }

    print("Trying to write to input console...");
    numWritten = 0;
    numWritten = Write("Hello",5,ConsoleInId );
    if( numWritten == -1 ) {
	print(" failed! (it should)\n");
    } else {
	print("succeeded! This is an error!\n");
	Exit(1);
    }

    print("Trying to write a negative number of bytes...");
    numWritten = 0;
    numWritten = Write("Hello", -2, ConsoleOutId );
    if( numWritten < 0 ) {
	print(" failed! (it should)\n");
    } else {
	print("succeeded! This is an error!\n");
	Exit(1);
    }

    print("Trying to write data into an invalid address...");
    numWritten = 0;
    numWritten = Write(&buf[256], 10, ConsoleOutId );
    if( numWritten < 0 ) {
	print(" failed! (it should)\n");
    } else {
	print("succeeded! This is an error!\n");
	Exit(1);
    }

}
