#include "syscall.h"
#include "io_lib.h"

int main() {
  char fileName[6];
  char buf[128];
  int result;
  OpenFileId fd;

  print("Enter the name of new file to create (five chars):");
  Read(fileName, 5, ConsoleInId );

  /* Check that files can be created */
  print("Creating file...");
  result = Create(fileName);
  if( result == 0 ) {
    print(fileName);
    print(" successful\n");
  } else {
    print(" failed!\n");
    Exit(1);
  }
  
  /* Try to open the file */
  print("Now opening ");
  print(fileName);
  print("...");
  fd = Open(fileName, "rw");
  if( fd > 1 ) {
    print(fileName);
    print(" successful\n");
  } else {
    print(" failed!\n");
    Exit(1);
  }
  
  /* Try to read data from the empty file */
  print("Attempting read from empty file...");
  result = 0;
  result = Read(buf, 24, fd);
  if( result == 0 ) {
    print(" no data read (as expected)\n");
  } else {
    print(" Error! Data read from empty file!\n");
    Exit(1);
  }

  /* Write some data to the file */
  print("Writing data to file...");
  result = 0;
  result = Write("Hello World\n",12,fd);
  if( result == 12 ){
    print(" successful\n");
  } else {
    print(" failed!\n");
  }

  /* Close the file */
  print("Closing file...");
  result = Close(fd);
  if( result == 0) {
    print(" successful\n");
  } else {
    print(" failed!\n");
    Exit(1);
  }

  /* Now Read Back the data */
  print("Re-opening file ...");
  result = 0;
  fd = Open(fileName, "rw");
  if( fd > 1 ) {
    print(" successful\n");
  } else {
    print(" failed!\n");
    Exit(1);
  }
  
  print("Reading back data...");
  result = Read(buf, 12, fd);
  if( result == 12 ) {
    print("Read 12 bytes: ");
    print(buf);
    print("\n");
  } else {
    print(" Error reading data!\n");
    Exit(1);
  }

  print("Closing file before exiting...");
  result = Close(fd);
  if( result == 0) {
    print(" successful\n");
  } else {
    print(" failed!\n");
    Exit(1);
  }
  
  print("TEST COMPLETED SUCCESSFULLY\n");
}
