#include "syscall.h"
#include "io_lib.h"

void main() {
    ProcessId pid, pid1, pid2;
    int exit_status, exit_status1, exit_status2;
    char ch;

    /* Check that join collects an explicit exit code */
    print("Execing process that will exit with known value...\n");    
    pid = Exec("../test/exit10");
    /* Introduce user-controlled delay before joining */
    print("Press any key to continue:\n");
    Read(&ch,1, ConsoleInId );
    print("Joining to process...\n");
    exit_status = Join(pid);
    print("Checking exit value...");
    if( exit_status == 10 ) {
        print("OK\n");
    } else {
      print("Unexpected status: ");
      printInt(exit_status);
      print("\n");
      Exit(1);
    }

    /* Out of order join */
    print("Now testing out of order join\n");
    print("Execing sort, then matmult and then joining in reverse order\n");
    pid1 = Exec("../test/sort");
    pid2 = Exec("../test/matmult");
    exit_status2 = Join(pid2);
    exit_status1 = Join(pid1);
    print("sort exited with exit code: ");
    printInt(exit_status1);
    print("\nmatmult exited with exit code: ");
    printInt(exit_status2);
    
    /* Try joining to a bad pid  */
    print("\nTrying to join to a non-existent pid... ");
    exit_status = Join( -101 );
    if( exit_status != -1 ) {
	print("Join succeeded! (shouldn't happen)\n");
	Exit(1);
    } else {
	print("Join failed (as expected)\n");
    }

    print("TEST COMPLETED SUCCESSFULLY!\n");
    Exit(0);
}
